#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include "step.h"
#include "resource.h"

#define IDI_ICON1	1

struct {
	 char Comport[20];
	 char Bohrtiefe[20];
	 char Fraestiefe[20];
	 char Delay[20];
	 char Count[20];
	} Dialog1;

unsigned long int MaschKonst=400; /* Halbschritte je Milimeter*/

HINSTANCE g_hInst;
HWND g_hwndStatus;
HWND g_hWnd;
HANDLE g_hWndProgress,g_hWndStatustext,g_hWndRun;
DWORD g_MyThreadID;

char ParamStr[300];
unsigned long Gebirge[14][20];
unsigned long BreakFlag=0,IntFlag=0;
signed long X1,Y1,X2,Y2,
            xmin,xmax,ymin,ymax,Layer,Speed=16;
char WorkFileName[300],TempFileName[300],TempFile=0,UsedLayers[100];
int AktLayers[64];
int Dmr[64];
char LayerNames[128][64];

float Scale=1;

int  Farben[]=
  {
  /*   bbggrr */
   0x00000000,  //00:schwarz
   0x00000000,  //01:schwarz
   0x0000007f,  //02:rot
   0x00007f00,  //03:grn
   0x00003f3f,  //04:gelb
   0x007f0000,  //05:blau
   0x003f003f,  //06:magenta
   0x003f3f00,  //07:cyan
   0x00000000,  //08:schwarz
   0x00202020,  //09:grau
   0x00000000,  //10:schwarz
   0x00000000,  //11:schwarz
   0x00000000,  //12:schwarz
   0x00000000,  //13:schwarz
   0x00000000,  //14:schwarz
   0x00000000,  //15:schwarz
   0x00000000,  //16:schwarz
   0x00000000,  //17:schwarz
   0x00000000,  //18:schwarz
   0x00000000,  //19:schwarz
   0x00000000,  //20:schwarz
   0x00000000,  //21:schwarz
   0x00000000,  //22:schwarz
   0x00000000,  //23:schwarz
   0x00000000,  //24:schwarz
   0x00000000,  //25:schwarz
   0x00000000,  //26:schwarz
   0x00000000,  //27:schwarz
   0x00000000,  //28:schwarz
   0x00000000,  //29:schwarz
   0x00000000,  //30:schwarz
   0x00000000,  //31:schwarz
   0x00000000,  //32:schwarz
   };



//---------------------------------------------------------------------------
long int Scan(int x,int y)
 {
 int breit,hoch;
 breit=(xmax-xmin-200)*10;  //2,5 mm linker + 2,5 mm rechter Rand
 hoch=(ymax-ymin-80)*10;    //2 mm oberer Rand
 x=x*4000+1000;          //quadranten in doppelschritte
 y*=4000;
 if (y<800) y=800; //2 mm unterer Rand
 if (y>hoch) y=hoch;
 if (x<1000) x=1000;
 if (x>breit) x=breit;
 StepMoveTo(x,y,0,200,120,16);
 hoch=StepSonde();
 Sleep(200);
 StepMoveTo(ActX,ActY,0,200,120,16);  //wieder hoch
 return(hoch);
 }
//---------------------------------------------------------------------------

BOOL CALLBACK Just_DlgProc(HWND hWnd,
                    UINT wMsg,
                    WPARAM wParam,
                    LPARAM lParam)
   {
   static int JustFlag=0;
   switch (wMsg)
     {
     case WM_INITDIALOG:
      {
       char st1[20];
       StepOpen(Dialog1.Comport);
       SendMessage(hWnd,WM_SETICON,(WPARAM) ICON_BIG,(LPARAM)LoadIcon(g_hInst,MAKEINTRESOURCE(IDI_ICON1)));
       SendMessage(GetDlgItem(hWnd,IDC_X),WM_SETTEXT,0,(LPARAM) "0");
       SendMessage(GetDlgItem(hWnd,IDC_Y),WM_SETTEXT,0,(LPARAM) "0");
       SendMessage(GetDlgItem(hWnd,IDC_Z),WM_SETTEXT,0,(LPARAM) "0");
       sprintf(st1,"%ld",Speed);
       SendMessage(GetDlgItem(hWnd,IDC_V),WM_SETTEXT,0,(LPARAM) st1);       
       SetFocus(GetDlgItem(hWnd,IDC_X));       
      }
      break;
      
     case WM_DESTROY:
      {
       StepClose();
      }
       
     case WM_COMMAND:
      {
      switch (LOWORD(wParam))
       {
       
       case IDC_OK:
        {
         char st1[20];
         ActX=1000;     //2,5 mm
	 ActY=0;
	 ActZ=0;
         EndDialog(hWnd,0);
         /* Eingegebene Werte speichern */
         return 0;
        }

       case IDC_CANCEL:
        {
         ActX=1000;     //2,5 mm
	 ActY=0;
	 ActZ=0;
         EndDialog(hWnd,1);
         /* Eingegebene Werte speichern */
         return 0;
        }
        
       case IDC_V:
        {
         if((HIWORD(wParam)==EN_CHANGE))
          {
          char st1[20];
          SendMessage(GetDlgItem(hWnd,IDC_V),WM_GETTEXT,19,(LPARAM) st1);       
          sscanf(st1,"%ld",&Speed);
          if(Speed>16) SendMessage(GetDlgItem(hWnd,IDC_V),WM_SETTEXT,0,(LPARAM) "16");
          if(Speed<1) SendMessage(GetDlgItem(hWnd,IDC_V),WM_SETTEXT,0,(LPARAM) "1");
          }
        return 0;
        }
        
       case IDC_X:
        {
         if((HIWORD(wParam)==EN_CHANGE)&&(!JustFlag))
          {
          JustFlag=1;
          SendMessage(GetDlgItem(hWnd,IDC_Y),WM_SETTEXT,0,(LPARAM) "0");
          SendMessage(GetDlgItem(hWnd,IDC_Z),WM_SETTEXT,0,(LPARAM) "0");
          JustFlag=0;
          }
        return 0;
        }
        
       case IDC_Y:
        {
         if((HIWORD(wParam)==EN_CHANGE)&&(!JustFlag))
          {
          JustFlag=1;
          SendMessage(GetDlgItem(hWnd,IDC_X),WM_SETTEXT,0,(LPARAM) "0");
          SendMessage(GetDlgItem(hWnd,IDC_Z),WM_SETTEXT,0,(LPARAM) "0");
          JustFlag=0;
          }
        return 0;
        }
        
       case IDC_Z:
        {
         if((HIWORD(wParam)==EN_CHANGE)&&(!JustFlag))
          {
          JustFlag=1;
          SendMessage(GetDlgItem(hWnd,IDC_Y),WM_SETTEXT,0,(LPARAM) "0");
          SendMessage(GetDlgItem(hWnd,IDC_X),WM_SETTEXT,0,(LPARAM) "0");
          JustFlag=0;
          }
        return 0;
        }

       case IDC_EXEC:
        {
         double x,y,z;
         int i;
         char st1[150];
         SendMessage(GetDlgItem(hWnd,IDC_X),WM_GETTEXT,40,(LPARAM) st1);
         sscanf(st1,"%LE",&x);
         SendMessage(GetDlgItem(hWnd,IDC_Y),WM_GETTEXT,40,(LPARAM) st1);
         sscanf(st1,"%LE",&y);
         SendMessage(GetDlgItem(hWnd,IDC_Z),WM_GETTEXT,40,(LPARAM) st1);
         sscanf(st1,"%LE",&z);

         StepRun(x*MaschKonst,y*MaschKonst,
                 z*MaschKonst,200,100,Speed);
        return 0;
        }

       case IDC_VERMESS:
        {
	signed long int a,b,x,y;
	signed long c,hoch,breit;
	char st1[200];

	breit=(xmax+200-xmin)/400;    //HPGL Schritte in zentimeter
	hoch=(ymax+200-ymin)/400;
	if((breit>0)&&(hoch>0))
	 {
	 ActX=1000;ActY=0;ActZ=0;
	 for (y=0;y<hoch+1;y++)
	 {
	  if(y&1)
	  {
	  for (x=breit;x>=0;x--)
	   {
	   Gebirge[x][y]=Scan(x,y);
	   }
	  }
	  else
	  {
	   for (x=0;x<breit+1;x++)
	   {
	   Gebirge[x][y]=Scan(x,y);
	   }
	  }
	 }
	 StepMoveTo(1000,0,0,200,120,16); //nach Hause
	 }
	else MessageBox(hWnd,"Keine Zeichnung geladen!","Meldung",MB_OK);
        return 0;
        }
        
       case IDC_AUTOJUST:
        {
	ActX=1000;ActY=0;ActZ=0;
	StepMoveTo(ActX,ActY+1000,ActZ,200,120,16);
	StepSonde();
	ActZ=-200;
	StepMoveTo(ActX,ActY,0,200,120,16);  //wieder hoch
	StepMoveTo(ActX,ActY-1000,ActZ,200,120,16);
        return 0;
        }

       }  
      }
     break;
     case WM_SYSCOMMAND:
      {
       switch(wParam)
        {
         case SC_CLOSE:
         {
         EndDialog(hWnd,1);
         }
         break;
        }
      }
      break;  
     }
   return FALSE; 
   }

DWORD WINAPI Bohren(LPVOID Param)
 {
 long a,oldx=0,oldy=0,x1,y1,x2,y2,lay,Tiefe;
 FILE *Datei,*Debug;
 char st1[200];

 ActX=1000;ActY=0;ActZ=0;
 sscanf(Dialog1.Bohrtiefe,"%ld",&Tiefe);
 Datei=fopen(WorkFileName,"r");
 if(!Datei)
  {
  MessageBox(0,"Datei konnte nicht geffnet werden!","Fehler",MB_OK);
  return(0);
  }
 a=0;
 while(!feof(Datei))
  {
  fgets(st1,150,Datei);
  if(st1[0]=='L')
   {
    sscanf(st1+1,"%ld %ld %ld %ld %ld",&lay,&x1,&y1,&x2,&y2);
    if(AktLayers[lay]) a++;
   }
  }
 rewind(Datei);
 SendMessage(g_hWndProgress, PBM_SETRANGE,0,MAKELPARAM(0, a));
 a=0;
 StepOpen(Dialog1.Comport);
 while((!feof(Datei))&(!BreakFlag))
  {
  fgets(st1,150,Datei);
  if(st1[0]=='L')
   {
    sscanf(st1+1,"%ld %ld %ld %ld %ld",&lay,&x1,&y1,&x2,&y2);
    x1-=xmin;
    y1-=ymin;
    x2-=xmin;
    y2-=ymin;
    x1=(x1+x2)/2;
    y1=(y1+y2)/2;
    if((AktLayers[lay])
      &&((x1!=oldx)||(y1!=oldy)))
      {
      sprintf(st1,"%.2f/%.2f",(float)x1/40,(float)y1/40);
      a++;
      SendMessage(g_hWndStatustext,WM_SETTEXT,0,(LPARAM) st1);
      SendMessage(g_hWndProgress, PBM_SETPOS,a,0);
      x1*=10;                       //von 1/40 mm (HPGL) in Halbschritte
      y1*=10;
      StepMoveTo(x1,y1,0,200,120,16);	/* Hinfahren */
      StepMoveTo(x1,y1,-Tiefe,250,10,Speed);  /* Bohren */
      Sleep(200);
      StepMoveTo(x1,y1,0,200,100,16);	/* Anheben */
      oldx=x1;
      oldy=y1;
      }
   }
   if(IntFlag)
   {
    StepMoveTo(1000,0,0,200,120,16);          //nach Hause
    StepClose();
    BreakFlag=DialogBox(g_hInst,MAKEINTRESOURCE(IDD_JUST),g_hWndRun,(DLGPROC)Just_DlgProc);
    IntFlag=0;
    StepOpen(Dialog1.Comport);
   }
  }
 fclose(Datei);
 SendMessage(g_hWndStatustext,WM_SETTEXT,0,(LPARAM) "ab nach Hause..");
 StepMoveTo(1000,0,0,200,120,16);
 EndDialog(g_hWndRun,0);
 StepClose();
 return(0);
 }

long int GetDepth(long int x,long int y)
 {
 signed long int
 qX,qY,restX,restY,dX,dYu,dYo,ul,ur,ol,or,yo,yu;

 x-=1000;                     //linker Rand 2,5 mm
 if(x<0) x=0;
 qX=x/4000; qY=y/4000;
 restX=x%4000;restY=y%4000;
 ul=Gebirge[qX][qY];
 ur=Gebirge[qX+1][qY];
 ol=Gebirge[qX][qY+1];
 or=Gebirge[qX+1][qY+1];

 dYo=or-ol;
 dYu=ur-ul;
 yo=dYo*restX/4000+ol;
 yu=dYu*restY/4000+ul;
 dX=yo-yu;
 return(dX*restY/4000+yu);
 }

DWORD WINAPI Fraesen(LPVOID Param)
 {
 signed long a,b,c,d,x1,y1,x2,y2,deltax,deltay,neux,neuy,lay,Tiefe,IsDown;
 double neudeltax,neudeltay;
 int Delay,Count,C1;
 FILE *Datei;
 char st1[200];
 ActX=1000;ActY=0;ActZ=0;
 sscanf(Dialog1.Fraestiefe,"%ld",&Tiefe);
 sscanf(Dialog1.Delay,"%d",&Delay);
 sscanf(Dialog1.Count,"%d",&Count);
 Datei=fopen(WorkFileName,"r");
 if(!Datei)
  {
  MessageBox(0,"Datei konnte nicht geffnet werden!","Fehler",MB_OK);
  return(0);
  }
 a=0;
 while(!feof(Datei))
  {
  fgets(st1,150,Datei);
  if(st1[0]=='L')
   {
    sscanf(st1+1,"%ld %ld %ld %ld",&lay,&x1,&y1,&x2);
    if(AktLayers[lay]) a++;
   }
  }
 rewind(Datei);
 SendMessage(g_hWndProgress, PBM_SETRANGE,0,MAKELPARAM(0, a*Count));
 StepOpen(Dialog1.Comport);
 a=0;
 for(C1=1;C1<Count+1;C1++)
 {
 while((!feof(Datei))&(!BreakFlag))
  {
  fgets(st1,150,Datei);
  if(st1[0]=='L')
   {
    sscanf(st1+1,"%ld %ld %ld %ld %ld",&lay,&x1,&y1,&x2,&y2);
    if((AktLayers[lay])
      &&(x1>(xmin+40)) && (x1<(xmax-40))
      &&(x2>(xmin+40)) && (x2<(xmax-40)))
     {
     x1-=xmin;
     y1-=ymin;
     x2-=xmin;
     y2-=ymin;
     sprintf(st1,"%d von %d: %.2f/%.2f - %.2f/%.2f", C1,Count,
                            (float)x1/60,(float)y1/60,
                            (float)x2/60,(float)y2/60);
     a++;
     SendMessage(g_hWndStatustext,WM_SETTEXT,0,(LPARAM) st1);
     SendMessage(g_hWndProgress, PBM_SETPOS,a,0);
     x1*=10;                       //von 1/40 mm (HPGL) in Halbschritte
     y1*=10;
     x2*=10;
     y2*=10;
     IsDown=1;
     if((x1!=ActX)||(y1!=ActY))     //mssen hinfahren?
      {
      IsDown=0;
      if(ActZ<0)                   //ist Stift unten?
       {
       Sleep(200);
       StepMoveTo(ActX,ActY,0,200,120,16); //anheben
       }
      StepMoveTo(x1,y1,0,200,120,16);      //zum Ziel
      }
     StepMoveTo(x1,y1,-(C1*Tiefe)-GetDepth(x1,y1),240,0,Speed);   //einstechen
     if(IsDown==0) Sleep(Delay); /* kurze Pause fr den Frser */
     do
      {
      deltax=x2-ActX;
      deltay=y2-ActY;
      if((abs(deltax)>4000)||(abs(deltay)>4000))                //mssen Splitten
       {
       if(abs(deltax)>abs(deltay))
        {
        if (deltax>0) neudeltax=4000; else neudeltax=-4000;
        neudeltay=deltay*neudeltax/deltax;
        }
       else
        {
        if (deltay>0) neudeltay=4000; else neudeltay=-4000;
        neudeltax=deltax*neudeltay/deltay;
        }
        deltax=neudeltax;
        deltay=neudeltay;
       }
      neux=ActX+deltax;neuy=ActY+deltay;
      StepMoveTo(neux,neuy,-(C1*Tiefe)-GetDepth(neux,neuy),240,0,Speed);     //Frsen
      }
     while((ActX!=x2)||(ActY!=y2));
     }
  }
  if(IntFlag)
   {
    StepMoveTo(ActX,ActY,0,200,120,16); 		//heben
    StepMoveTo(1000,0,0,200,120,16);          	//nach Hause
    StepClose();
    BreakFlag=DialogBox(g_hInst,MAKEINTRESOURCE(IDD_JUST),g_hWndRun,(DLGPROC)Just_DlgProc);
    IntFlag=0;
    StepOpen(Dialog1.Comport);
   }
  }
  Sleep(Delay); /* kurze Pause fr den Frser */
  rewind(Datei);
  }
 fclose(Datei);
 SendMessage(g_hWndStatustext,WM_SETTEXT,0,(LPARAM) "ab nach Hause..");
 StepMoveTo(ActX,ActY,0,200,120,16);       //Stift heben
 StepMoveTo(1000,0,0,200,120,16);          //zurck nach Hause
 EndDialog(g_hWndRun,0);
 StepClose();
 return(0);
 }


BOOL CALLBACK Run_DlgProc(HWND hWnd,
                    UINT wMsg,
                    WPARAM wParam,
                    LPARAM lParam)
   {
   static int JustFlag=0;
   switch (wMsg)
     {
     case WM_INITDIALOG:
      {
       char st1[300];
       
       g_hWndStatustext=GetDlgItem(hWnd,IDC_STATUSTEXT);
       g_hWndRun=hWnd;
       SendMessage(hWnd,WM_SETICON,(WPARAM) ICON_BIG,(LPARAM)LoadIcon(g_hInst,MAKEINTRESOURCE(IDI_ICON1)));
       SendMessage(g_hWndStatustext,WM_SETTEXT,0,(LPARAM) "");

        g_hWndProgress=CreateWindowEx(0,PROGRESS_CLASS,(LPSTR) NULL,WS_CHILD | WS_VISIBLE, 10,10,290,10,hWnd,(HMENU) 0,g_hInst,NULL);
        SendMessage(g_hWndProgress, PBM_SETRANGE,0,MAKELPARAM(0, 100));
        SendMessage(g_hWndProgress, PBM_SETPOS,50,0);

       switch(lParam)
        {
        case CM_BOHREN:
         {
	  LPVOID TestParam;
	  BreakFlag=0;
	  CreateThread(NULL,
              0,
              Bohren,
              TestParam,
              0,
              &g_MyThreadID);

         strcpy(st1,"Bohren");
         break;
         }

        case CM_FRAESEN:
         {
	  LPVOID TestParam;
	  BreakFlag=0;
	  CreateThread(NULL,
              0,
              Fraesen,
              TestParam,
              0,
              &g_MyThreadID);

         strcpy(st1,"Fraesen");         
         break;
         }
        default:
         {
         strcpy(st1,"Wei nicht..");
         
         break;
         }
        }
       SendMessage(hWnd,WM_SETTEXT,0,(LPARAM) st1); 

      }
      break;
      
     case WM_DESTROY:
      {
      }
       
     case WM_COMMAND:
      {
      switch (LOWORD(wParam))
       {
        
       case IDC_STOP:
        {
	IntFlag=1;
        SendMessage(g_hWndStatustext,WM_SETTEXT,0,(LPARAM) "Es wird (ab)gebrochen!");	
        return 0;
        }

       }  
      }
     break;
     case WM_SYSCOMMAND:
      {
       switch(wParam)
        {
         case SC_CLOSE:
         {
         EndDialog(hWnd,1);
         }
         break;
        }
      }
      break;  
     }
   return FALSE; 
   }



//---------------------------------------------------------------------------
int MyFileOpen(char *FileName)
 {
 FILE *Datei;
 int i;
 char st1[600],*cp,*cp1,CnvPath[300],st2[20];
 char Name[300];
 unsigned long a=0;
 ymin=xmin=+2000000000;
 ymax=xmax=-2000000000;
  {
  for(a=0;a<33;a++) 
   {
   UsedLayers[3*a]='-';
   UsedLayers[3*a+1]='-';
   UsedLayers[3*a+2]='-';
   AktLayers[a]=0;
   Dmr[a]=0;
   sprintf(LayerNames[a],"Stift %d",a);
   }
  if (TempFile)
   {
   remove(TempFileName);
   TempFile=0;
   }
   cp=strrchr(FileName,'.');
   if((strncmp(cp,".CNC",3)&&(strncmp(cp,".cnc",3))))
    {
     strcpy(TempFileName,ParamStr);
     strcpy(CnvPath,ParamStr);
     strcat(TempFileName,".cnc");
     cp=strrchr(CnvPath,'\\');
     if(cp) *cp=0;
     strcat(CnvPath,"\\hpgl.exe");
     sprintf(st1,"%s %s %s",CnvPath,FileName,TempFileName);
     system(st1);
     TempFile=1;
     /* Versuchen, die Textdatei mit den Stiftnamen einzulesen*/
     strcpy(st1,FileName);
     cp=strrchr(st1,'.');
     strcpy(cp,".txt");
     cp=st1;
     if(st1[0]=='"') cp++;
     Datei=fopen(cp,"r");
     if(Datei)
      {
      while(!feof(Datei))
       {
       double lf;
       fgets(st1,200,Datei);
       lf=0;
       cp=strstr(st1,"Drill");
       if(cp)
        {
        cp1=strstr(st1,"Dia=");
        if(cp1) sscanf(cp1+4,"%lfmm",&lf);
        }
       cp=strstr(st1," Depth");
       if(cp) 
        {
        *cp=0;
        }
       sscanf(st1,"T%d;",&i);
       Dmr[i]=lf*MaschKonst/20;
       cp=strchr(st1,' ');
       if(!cp) cp=st1; else cp++;
       strcpy(LayerNames[i],cp);
       }
      fclose(Datei);
      }
    }
  else 
   {
   if(FileName[0]=='"')
    {
    FileName[strlen(FileName)-1]=0;
    strcpy(TempFileName,FileName+1);
    }
   else strcpy(TempFileName,FileName);
   }

  Datei=fopen(TempFileName,"r");
  if(!Datei)
   {
   SendMessage(g_hwndStatus,SB_SETTEXT,(WPARAM) 0,(LPARAM) "keine Datei");
   }
  else
  {
  while(!feof(Datei))
   {
    fgets(st1,150,Datei);
    sscanf(st1+1,"%ld %ld %ld %ld %ld",&Layer,&X1,&Y1,&X2,&Y2);
    sprintf(st2,"%02d",Layer);
    strncpy(UsedLayers+3*Layer,st2,2);
    if((Layer<33)&&(Layer>0))
    a++;
     {
     if(X1>xmax) xmax=X1;
     if(X1<xmin) xmin=X1;
     if(Y1>ymax) ymax=Y1;
     if(Y1<ymin) ymin=Y1;
     if(st1[0]=='L')
      {
      if(X2>xmax) xmax=X2;
      if(X2<xmin) xmin=X2;
      if(Y2>ymax) ymax=Y2;
      if(Y2<ymin) ymin=Y2;
      }
     }
   }
   fclose(Datei);
  }
  strcpy(WorkFileName,TempFileName);
  UsedLayers[100]=0;
  sprintf(st1,"%ld Elemente, %.2f mm hoch, %.2f mm breit Stifte %s",
                            a,(float)(ymax-ymin)/40,
                              (float)(xmax-xmin)/40,UsedLayers+3);
  SendMessage(g_hwndStatus,SB_SETTEXT,(WPARAM) 0,(LPARAM) st1);

  strcpy(Name,FileName);
  strcat(Name," - Ingos FrsBohrPlotter");
  SendMessage(g_hWnd,WM_SETTEXT,0,(LPARAM) Name);
  }
  InvalidateRect(g_hWnd,NULL,TRUE);
  return 0;
 }



BOOL CALLBACK Dialog1_DlgProc(HWND hWnd,
                    UINT wMsg,
                    WPARAM wParam,
                    LPARAM lParam)
   {
   switch (wMsg)
     {
     case WM_INITDIALOG:
      {
       int i;
       char st1[10];
       HANDLE ComHandle;
       SendMessage(hWnd,WM_SETICON,(WPARAM) ICON_BIG,(LPARAM)LoadIcon(g_hInst,MAKEINTRESOURCE(IDI_ICON1)));
	/* Eingabefelder initialisieren */
       SendMessage(GetDlgItem(hWnd,IDC_COMPORT),WM_SETTEXT,(WPARAM) 0,(LPARAM) Dialog1.Comport);
       SendMessage(GetDlgItem(hWnd,IDC_BOHRTIEFE),WM_SETTEXT,(WPARAM) 0,(LPARAM) Dialog1.Bohrtiefe);
       SendMessage(GetDlgItem(hWnd,IDC_FRAESTIEFE),WM_SETTEXT,(WPARAM) 0,(LPARAM) Dialog1.Fraestiefe);
       SendMessage(GetDlgItem(hWnd,IDC_DELAY),WM_SETTEXT,(WPARAM) 0,(LPARAM) Dialog1.Delay);
       SendMessage(GetDlgItem(hWnd,IDC_COUNT),WM_SETTEXT,(WPARAM) 0,(LPARAM) Dialog1.Count);
       SetFocus(GetDlgItem(hWnd,IDC_COMPORT));
	
       for(i=1;i<10;i++)
	{
	sprintf(st1,"com%d",i);
	ComHandle=CreateFile(st1,
                     GENERIC_READ|GENERIC_WRITE,    //beabsichigter Zugriff
                     0,                             //kein sharing
                     0,                             //security attributes
                     OPEN_EXISTING,
                     FILE_ATTRIBUTE_NORMAL,
                     0);
	if(ComHandle!=INVALID_HANDLE_VALUE)
	 {
	 SendMessage(GetDlgItem(hWnd,IDC_COMPORT),CB_ADDSTRING,0,(LPARAM) st1);
	 CloseHandle(ComHandle);
	 ComHandle=INVALID_HANDLE_VALUE;
	 }
        }

       for(i=1;i<33;i++)
        {
        /*Checkboxen der Layer initialisieren*/
        SendMessage(GetDlgItem(hWnd,IDC_LAYER1+i-1),WM_SETTEXT,(WPARAM) 0,(LPARAM) LayerNames[i]);
        if(AktLayers[i])
         SendMessage(GetDlgItem(hWnd,IDC_LAYER1+i-1),BM_SETCHECK,(WPARAM) BST_CHECKED,(LPARAM) 0);
        else
         SendMessage(GetDlgItem(hWnd,IDC_LAYER1+i-1),BM_SETCHECK,(WPARAM) BST_UNCHECKED,(LPARAM) 0);
        
         if(UsedLayers[3*i]!='-')
	  {
          EnableWindow(GetDlgItem(hWnd,IDC_LAYER1+i-1),TRUE);
          sprintf(st1,"Stift %d",i);
	  }
        } 
      }
      break;
     case WM_COMMAND:
      {
      switch (LOWORD(wParam))
       {
       case IDC_PUSHBUTTON_OK:
        {
         char st1[20];
         int i;
         /* Eingegebene Werte speichern */
	  SendMessage(GetDlgItem(hWnd,IDC_COMPORT),WM_GETTEXT,(WPARAM) 16,(LPARAM) Dialog1.Comport);
	  SendMessage(GetDlgItem(hWnd,IDC_BOHRTIEFE),WM_GETTEXT,(WPARAM) 16,(LPARAM) Dialog1.Bohrtiefe);
	  SendMessage(GetDlgItem(hWnd,IDC_FRAESTIEFE),WM_GETTEXT,(WPARAM) 16,(LPARAM) Dialog1.Fraestiefe);
	  SendMessage(GetDlgItem(hWnd,IDC_DELAY),WM_GETTEXT,(WPARAM) 16,(LPARAM) Dialog1.Delay);
	  SendMessage(GetDlgItem(hWnd,IDC_COUNT),WM_GETTEXT,(WPARAM) 16,(LPARAM) Dialog1.Count);
          for(i=1;i<33;i++)
          {
          /*Checkboxen der Layer lesen*/
          if(SendMessage(GetDlgItem(hWnd,IDC_LAYER1+i-1),BM_GETCHECK,(WPARAM) 0,(LPARAM) 0)==BST_CHECKED) AktLayers[i]=1;
          else AktLayers[i]=0;
          } 
         EndDialog(hWnd,0);
        }
        break;      
       }  
      }
     break;
     case WM_SYSCOMMAND:
      {
       switch(wParam)
        {
         case SC_CLOSE:
         {
         EndDialog(hWnd,0);
         }
         break;
        }
      }
      break;  
     }
   return FALSE; 
   }

LRESULT CALLBACK WndProc (HWND hWnd, UINT uiMessage,
					WPARAM wParam, LPARAM lParam)
	{
	int nParts=3;

	  switch(uiMessage)
	  {
	   case WM_DESTROY:
	    {
            /* INIFile schreiben */
            char st1[300];
            FILE *Datei;
            strcpy(st1,ParamStr);
            strcat(st1,".ini");
            Datei=fopen(st1,"w");
            if(Datei)
            {
             fprintf(Datei,"%s\n",Dialog1.Comport);
             fprintf(Datei,"%s\n",Dialog1.Bohrtiefe);
             fprintf(Datei,"%s\n",Dialog1.Fraestiefe);
             fprintf(Datei,"%s\n",Dialog1.Delay);
             fclose(Datei);
            }      

	       if (TempFile)
		{
		remove(TempFileName);
		TempFile=0;
		}
	     PostQuitMessage(0);
	     return 0;
	    } 
	   case WM_CREATE:
             {	     
	     /* StatusBar erzeugen */

		int nWidth,i,*lpParts;
		char st1[300],*cp;
		int x,y;
		FILE *Datei;
		RECT rcClient;
		HANDLE hloc;
		g_hWnd=hWnd;
		g_hwndStatus = CreateWindowEx( 
			0,                      // no extended styles 
			STATUSCLASSNAME,        // name of status window class 
			(LPCTSTR) NULL,         // no text when first created 
			SBARS_SIZEGRIP |        // includes a sizing grip 
			WS_VISIBLE |
			WS_CHILD,               // creates a child window 
			0, 0, 0, 0,             // ignores size and position 
			hWnd,              	// handle to parent window 
			(HMENU) 0,       	// child window identifier 
			g_hInst,                // handle to application instance 
			NULL);                  // no window creation data 
 
		GetClientRect(hWnd, &rcClient); 
		hloc = LocalAlloc(LHND, sizeof(int) * nParts); 
		lpParts = (int*)LocalLock(hloc); 
		nWidth = rcClient.right / nParts; 
		for (i = 0; i < nParts; i++) 
		{ 
		 lpParts[i] = nWidth; 
		 nWidth += nWidth; 
		} 
		SendMessage(g_hwndStatus, SB_SETPARTS, (WPARAM) nParts,(LPARAM) lpParts); 
		LocalUnlock(hloc); 
		LocalFree(hloc); 
		for(x=0;x<14;x++)
		{
		for(y=0;y<20;y++) Gebirge[x][y]=200;
		}
		/* Datei in der Kommandozeile angegeben? */
		strcpy(st1,GetCommandLine());
		cp=st1;
		if(*cp=='"') 
		 {
		 cp=strchr(cp+1,'"'); /*zweites Gnsefsschen*/
		 if(!cp) return 0;
		 cp++;
		 }
		else
		 {
		 cp=strchr(cp,' ');
		 } 
		if (cp)
		  {
		   if(*cp==' ') 
		    {
		    cp++;
		    if(strlen(cp)>3)
		    MyFileOpen(cp);
		    }
		  }

	       strcpy(Dialog1.Comport,"com1"); 
	       strcpy(Dialog1.Bohrtiefe,"10");
	       strcpy(Dialog1.Fraestiefe,"10");
	       strcpy(Dialog1.Delay,"100");
	       strcpy(Dialog1.Count,"1");
		/* Versuchen INIFile einzulesen */
		strcpy(st1,ParamStr);
		strcat(st1,".ini");
		Datei=fopen(st1,"r");
		if(Datei)
		{
		if(fscanf(Datei,"%s\n",st1)==1) strcpy(Dialog1.Comport,st1);
		if(fscanf(Datei,"%s\n",st1)==1) strcpy(Dialog1.Bohrtiefe,st1);
		if(fscanf(Datei,"%s\n",st1)==1) strcpy(Dialog1.Fraestiefe,st1);
		if(fscanf(Datei,"%s\n",st1)==1) strcpy(Dialog1.Delay,st1);
		fclose (Datei);
		}
	       
	     return 0;
	     }

	    case WM_SIZE:
	     {
             int i,inc,width[5];
             char puffer[30];
	     RECT rcClient;
             GetClientRect(hWnd, &rcClient);
             width[0] = 950;
             width[1] = 1000;
             width[2] = rcClient.right;
              
             SendMessage(g_hwndStatus, SB_SETPARTS, (WPARAM) 3,(LPARAM) width);
       
             //einfach an den StatusBar weitergeben
             SendMessage(g_hwndStatus,WM_SIZE,wParam,lParam);
             SendMessage(hWnd,WM_PAINT,0,0);
	     return 0;
	     } 
	      
	    case WM_PAINT:
	     {
      		PAINTSTRUCT ps;
      		HDC hdc;
      		HPEN pens[10],penalt;
      		HBRUSH grau,weiss,brushalt;
		RECT rcClient;
                char puffer[30];

		FILE *Datei;
		char st1[200];
		signed long SizeX,SizeY,Di;
		float ScaleX,ScaleY;
		int X1,Y1,X2,Y2,a,LayAll=1;

		hdc=GetDC(hWnd);
		
		for(a=0;a<33;a++) pens[a]=CreatePen(PS_SOLID,1,Farben[a]);
      		grau=CreateSolidBrush(RGB(200,200,200));
      		weiss=CreateSolidBrush(RGB(255,255,255));
      		penalt=(HPEN)SelectObject(hdc,pens[0]);
		GetClientRect(hWnd, &rcClient);
		rcClient.bottom-=18;		/* Statusleiste aussparen */
		FillRect(hdc,&rcClient,grau); 	/* gesamtes Fenster grau machen */


		//ist berhaupt schon eine Datei geladen?
		if((xmax>xmin)&&(ymax>ymin))
		{
		 /*Testen ob irgendein Stift aktiv*/
		 for(a=1;a<33;a++) if(AktLayers[a]) LayAll=0;
		 Datei=fopen(WorkFileName,"r");
		 if(Datei)
		 {
		  RECT Blatt;
		  SizeX=xmax-xmin;
		  SizeY=ymax-ymin;
		  ScaleX=(float)(rcClient.right-rcClient.left)/(float)SizeX;
		  ScaleY=(float)(rcClient.bottom-rcClient.top)/(float)SizeY;
		  if(ScaleY>ScaleX) Scale=ScaleX;
		  else Scale=ScaleY;

                  Blatt.left=0;
                  Blatt.right=SizeX*Scale;
                  Blatt.top=0;
                  Blatt.bottom=SizeY*Scale;
       		  FillRect(hdc,&Blatt,weiss);
		  while(!feof(Datei))
		  {
		   fgets(st1,150,Datei);
		   sscanf(st1+1,"%ld %ld %ld %ld %ld",&Layer,&X1,&Y1,&X2,&Y2);
		   Layer&=31;
                   if(st1[0]=='L')
		   {
		    if(((AktLayers[Layer])||(LayAll))
		       &&(X1>(xmin+40)) && (X1<(xmax-40))
		       &&(X2>(xmin+40)) && (X2<(xmax-40)))

		    {
		     X1=(X1-xmin)*Scale;
		     Y1=(-Y1+ymax)*Scale;
		     X2=(X2-xmin)*Scale;
		     Y2=(-Y2+ymax)*Scale;
		     if(Dmr[Layer])
		      {
		      SelectObject(hdc,pens[Layer]);
		      Ellipse(hdc,X1-Dmr[Layer]*Scale,Y1-Dmr[Layer]*Scale,
		                  X1+Dmr[Layer]*Scale+2,Y1+Dmr[Layer]*Scale+2);
		      }
		     else
		     if((X1==X2)&&(Y1==Y2))
		         SetPixel(hdc,X1,Y1,Farben[Layer]); //nur ein Punkt
		     else
			{
			 SelectObject(hdc,pens[Layer]);
      		         MoveToEx(hdc,X1,Y1,0);
      		         LineTo(hdc,X2,Y2);
			}
                     }
                    }
		  }
		  fclose(Datei);
		 }
		}


		SelectObject(hdc,penalt);
		/* gebrauchte Betriebsmittel zurckgeben */
      		for(a=0;a<33;a++) DeleteObject(pens[a]);
      		DeleteObject(grau);
      		DeleteObject(weiss);     
		ReleaseDC(hWnd,hdc);
      		BeginPaint(hWnd,&ps);      
      		EndPaint(hWnd,&ps);
                SendMessage(g_hwndStatus,SB_SETTEXT,(WPARAM) 1,(LPARAM) Dialog1.Comport);
		return 0;
	     }	


	   case WM_COMMAND:
	     switch (LOWORD(wParam))
	     {
	     case CM_DATEIOEFFNEN:
	      {
	       OPENFILENAME ofn;
               char FileName[300];
               FileName[0]=0;           
               ZeroMemory(&ofn,sizeof(ofn));
               ofn.lStructSize=sizeof(ofn);
	       ofn.hwndOwner=hWnd;
	       ofn.lpstrFile=FileName;
	       ofn.nMaxFile=290;
	       ofn.lpstrTitle="Datei whlen!";
	       ofn.Flags=OFN_FILEMUSTEXIST;
	             
               if(GetOpenFileName(&ofn))
                {
                 MyFileOpen(FileName);
                }

	      }
	      return 0;
	      
	     case CM_DATEIBEENDEN:
	       SendMessage(hWnd,WM_CLOSE,0,0);
	       return 0;
	       
	     case CM_DIALOG1:
	       DialogBox(g_hInst,MAKEINTRESOURCE(IDD_DIALOG1),hWnd,(DLGPROC)Dialog1_DlgProc);
	       SendMessage(hWnd,WM_PAINT,0,0); 
	       return 0;
	       
	     case CM_JUST:
	      {
	       DialogBox(g_hInst,MAKEINTRESOURCE(IDD_JUST),hWnd,(DLGPROC)Just_DlgProc);
	       return;
	      } 

	     case CM_BOHREN:
	      {
	      DialogBoxParam(g_hInst,MAKEINTRESOURCE(IDD_RUN),hWnd,(DLGPROC)Run_DlgProc,
	                     (LPARAM) CM_BOHREN);
	      return 0;
	      }
	      
	     case CM_FRAESEN:
	      {
	      DialogBoxParam(g_hInst,MAKEINTRESOURCE(IDD_RUN),hWnd,(DLGPROC)Run_DlgProc,
	                     (LPARAM) CM_FRAESEN);
	      return 0;
	      }

             case CM_REFRESH:
              {
              SendMessage(hWnd,WM_PAINT,0,0);
              return 0;
              }
	     }
            return 0;
	   default:
	     return DefWindowProc (hWnd, uiMessage, wParam, lParam);  
	  }
	}



int APIENTRY WinMain(HINSTANCE hInstance,
			HINSTANCE hPrevInstance,
			LPSTR	lpCmdLine,
			int	nCmdShow)
	{
	g_hInst=hInstance;
	InitCommonControls();
	
	
	char *cp,st1[200];
	/* Programmpfad aus der Kommandozeile auswerten */
	strcpy(st1,GetCommandLine());
	if(st1[0]=='"')
	 {
	 /* schliessendes Gnsefchen entfernen */
	 cp=strchr(st1+1,'"');
	 if(cp) *cp=0;
	 /* Endung entfernen */
	 cp=strrchr(st1+1,'.');
	 if(cp) *cp=0;
	 strcpy(ParamStr,st1+1);
	 }
	else
	 {
	 cp=strchr(st1,' ');
	 if (cp) *cp = 0; /* mehr als ein Parameter */
	 cp=strrchr(st1,'.');
	 if (cp) *cp = 0; /* evtl Endung entfernen */
	 GetCurrentDirectory(280,ParamStr);
	 strcat(ParamStr,"\\");
	 strcat(ParamStr,st1);
	 }
	
	
	WNDCLASS WndClass;
	WndClass.style =CS_OWNDC | CS_VREDRAW | CS_HREDRAW;
	WndClass.cbClsExtra=0;	
	WndClass.cbWndExtra=0;
	WndClass.lpfnWndProc=WndProc;
	WndClass.hInstance=hInstance;	
	WndClass.hbrBackground=(HBRUSH)(COLOR_WINDOW+1);	
	WndClass.hCursor=0; /* LoadCursor(hInstance,MAKEINTRESOURCE(IDC_CURSOR2)); */
	WndClass.hIcon=LoadIcon(hInstance,	MAKEINTRESOURCE(IDI_ICON1));
	WndClass.lpszMenuName=MAKEINTRESOURCE(IDM_MENU1);
	WndClass.lpszClassName="WinProg";
	RegisterClass(&WndClass);
	
	g_hWnd=CreateWindow("WinProg","Winplot",WS_OVERLAPPEDWINDOW,
				0,0,400,400,NULL,NULL,hInstance,NULL);
	ShowWindow(g_hWnd,nCmdShow);
	UpdateWindow((g_hWnd));
	
	MSG Message;
	while (GetMessage(&Message,NULL,0,0))
	 {
	 DispatchMessage(&Message);
	 TranslateMessage(&Message);
	 }
	 return(Message.wParam);	 
      }
